t / test-lib.shon commit reset: disallow "reset --keep" outside a work tree (ab892a1)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# if --tee was passed, write the output not only to the terminal, but
   7# additionally to the file test-results/$BASENAME.out, too.
   8case "$GIT_TEST_TEE_STARTED, $* " in
   9done,*)
  10        # do not redirect again
  11        ;;
  12*' --tee '*|*' --va'*)
  13        mkdir -p test-results
  14        BASE=test-results/$(basename "$0" .sh)
  15        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  16         echo $? > $BASE.exit) | tee $BASE.out
  17        test "$(cat $BASE.exit)" = 0
  18        exit
  19        ;;
  20esac
  21
  22# Keep the original TERM for say_color
  23ORIGINAL_TERM=$TERM
  24
  25# For repeatability, reset the environment to known value.
  26LANG=C
  27LC_ALL=C
  28PAGER=cat
  29TZ=UTC
  30TERM=dumb
  31export LANG LC_ALL PAGER TERM TZ
  32EDITOR=:
  33unset VISUAL
  34unset GIT_EDITOR
  35unset AUTHOR_DATE
  36unset AUTHOR_EMAIL
  37unset AUTHOR_NAME
  38unset COMMIT_AUTHOR_EMAIL
  39unset COMMIT_AUTHOR_NAME
  40unset EMAIL
  41unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  42unset GIT_AUTHOR_DATE
  43GIT_AUTHOR_EMAIL=author@example.com
  44GIT_AUTHOR_NAME='A U Thor'
  45unset GIT_COMMITTER_DATE
  46GIT_COMMITTER_EMAIL=committer@example.com
  47GIT_COMMITTER_NAME='C O Mitter'
  48unset GIT_DIFF_OPTS
  49unset GIT_DIR
  50unset GIT_WORK_TREE
  51unset GIT_EXTERNAL_DIFF
  52unset GIT_INDEX_FILE
  53unset GIT_OBJECT_DIRECTORY
  54unset GIT_CEILING_DIRECTORIES
  55unset SHA1_FILE_DIRECTORIES
  56unset SHA1_FILE_DIRECTORY
  57GIT_MERGE_VERBOSITY=5
  58export GIT_MERGE_VERBOSITY
  59export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  60export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  61export EDITOR
  62GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
  63
  64# Protect ourselves from common misconfiguration to export
  65# CDPATH into the environment
  66unset CDPATH
  67
  68case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  69        1|2|true)
  70                echo "* warning: Some tests will not work if GIT_TRACE" \
  71                        "is set as to trace on STDERR ! *"
  72                echo "* warning: Please set GIT_TRACE to something" \
  73                        "other than 1, 2 or true ! *"
  74                ;;
  75esac
  76
  77# Convenience
  78#
  79# A regexp to match 5 and 40 hexdigits
  80_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  81_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  82
  83# Each test should start with something like this, after copyright notices:
  84#
  85# test_description='Description of this test...
  86# This test checks if command xyzzy does the right thing...
  87# '
  88# . ./test-lib.sh
  89[ "x$ORIGINAL_TERM" != "xdumb" ] && (
  90                TERM=$ORIGINAL_TERM &&
  91                export TERM &&
  92                [ -t 1 ] &&
  93                tput bold >/dev/null 2>&1 &&
  94                tput setaf 1 >/dev/null 2>&1 &&
  95                tput sgr0 >/dev/null 2>&1
  96        ) &&
  97        color=t
  98
  99while test "$#" -ne 0
 100do
 101        case "$1" in
 102        -d|--d|--de|--deb|--debu|--debug)
 103                debug=t; shift ;;
 104        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 105                immediate=t; shift ;;
 106        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 107                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 108        -h|--h|--he|--hel|--help)
 109                help=t; shift ;;
 110        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 111                verbose=t; shift ;;
 112        -q|--q|--qu|--qui|--quie|--quiet)
 113                quiet=t; shift ;;
 114        --with-dashes)
 115                with_dashes=t; shift ;;
 116        --no-color)
 117                color=; shift ;;
 118        --no-python)
 119                # noop now...
 120                shift ;;
 121        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 122                valgrind=t; verbose=t; shift ;;
 123        --tee)
 124                shift ;; # was handled already
 125        --root=*)
 126                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 127                shift ;;
 128        *)
 129                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 130        esac
 131done
 132
 133if test -n "$color"; then
 134        say_color () {
 135                (
 136                TERM=$ORIGINAL_TERM
 137                export TERM
 138                case "$1" in
 139                        error) tput bold; tput setaf 1;; # bold red
 140                        skip)  tput bold; tput setaf 2;; # bold green
 141                        pass)  tput setaf 2;;            # green
 142                        info)  tput setaf 3;;            # brown
 143                        *) test -n "$quiet" && return;;
 144                esac
 145                shift
 146                printf "* %s" "$*"
 147                tput sgr0
 148                echo
 149                )
 150        }
 151else
 152        say_color() {
 153                test -z "$1" && test -n "$quiet" && return
 154                shift
 155                echo "* $*"
 156        }
 157fi
 158
 159error () {
 160        say_color error "error: $*"
 161        GIT_EXIT_OK=t
 162        exit 1
 163}
 164
 165say () {
 166        say_color info "$*"
 167}
 168
 169test "${test_description}" != "" ||
 170error "Test script did not set test_description."
 171
 172if test "$help" = "t"
 173then
 174        echo "$test_description"
 175        exit 0
 176fi
 177
 178exec 5>&1
 179if test "$verbose" = "t"
 180then
 181        exec 4>&2 3>&1
 182else
 183        exec 4>/dev/null 3>/dev/null
 184fi
 185
 186test_failure=0
 187test_count=0
 188test_fixed=0
 189test_broken=0
 190test_success=0
 191
 192die () {
 193        code=$?
 194        if test -n "$GIT_EXIT_OK"
 195        then
 196                exit $code
 197        else
 198                echo >&5 "FATAL: Unexpected exit with code $code"
 199                exit 1
 200        fi
 201}
 202
 203GIT_EXIT_OK=
 204trap 'die' EXIT
 205
 206# The semantics of the editor variables are that of invoking
 207# sh -c "$EDITOR \"$@\"" files ...
 208#
 209# If our trash directory contains shell metacharacters, they will be
 210# interpreted if we just set $EDITOR directly, so do a little dance with
 211# environment variables to work around this.
 212#
 213# In particular, quoting isn't enough, as the path may contain the same quote
 214# that we're using.
 215test_set_editor () {
 216        FAKE_EDITOR="$1"
 217        export FAKE_EDITOR
 218        EDITOR='"$FAKE_EDITOR"'
 219        export EDITOR
 220}
 221
 222test_decode_color () {
 223        sed     -e 's/.\[1m/<WHITE>/g' \
 224                -e 's/.\[31m/<RED>/g' \
 225                -e 's/.\[32m/<GREEN>/g' \
 226                -e 's/.\[33m/<YELLOW>/g' \
 227                -e 's/.\[34m/<BLUE>/g' \
 228                -e 's/.\[35m/<MAGENTA>/g' \
 229                -e 's/.\[36m/<CYAN>/g' \
 230                -e 's/.\[m/<RESET>/g'
 231}
 232
 233test_tick () {
 234        if test -z "${test_tick+set}"
 235        then
 236                test_tick=1112911993
 237        else
 238                test_tick=$(($test_tick + 60))
 239        fi
 240        GIT_COMMITTER_DATE="$test_tick -0700"
 241        GIT_AUTHOR_DATE="$test_tick -0700"
 242        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 243}
 244
 245# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 246#
 247# This will commit a file with the given contents and the given commit
 248# message.  It will also add a tag with <message> as name.
 249#
 250# Both <file> and <contents> default to <message>.
 251
 252test_commit () {
 253        file=${2:-"$1.t"}
 254        echo "${3-$1}" > "$file" &&
 255        git add "$file" &&
 256        test_tick &&
 257        git commit -m "$1" &&
 258        git tag "$1"
 259}
 260
 261# Call test_merge with the arguments "<message> <commit>", where <commit>
 262# can be a tag pointing to the commit-to-merge.
 263
 264test_merge () {
 265        test_tick &&
 266        git merge -m "$1" "$2" &&
 267        git tag "$1"
 268}
 269
 270# This function helps systems where core.filemode=false is set.
 271# Use it instead of plain 'chmod +x' to set or unset the executable bit
 272# of a file in the working directory and add it to the index.
 273
 274test_chmod () {
 275        chmod "$@" &&
 276        git update-index --add "--chmod=$@"
 277}
 278
 279# Use test_set_prereq to tell that a particular prerequisite is available.
 280# The prerequisite can later be checked for in two ways:
 281#
 282# - Explicitly using test_have_prereq.
 283#
 284# - Implicitly by specifying the prerequisite tag in the calls to
 285#   test_expect_{success,failure,code}.
 286#
 287# The single parameter is the prerequisite tag (a simple word, in all
 288# capital letters by convention).
 289
 290test_set_prereq () {
 291        satisfied="$satisfied$1 "
 292}
 293satisfied=" "
 294
 295test_have_prereq () {
 296        case $satisfied in
 297        *" $1 "*)
 298                : yes, have it ;;
 299        *)
 300                ! : nope ;;
 301        esac
 302}
 303
 304# You are not expected to call test_ok_ and test_failure_ directly, use
 305# the text_expect_* functions instead.
 306
 307test_ok_ () {
 308        test_success=$(($test_success + 1))
 309        say_color "" "  ok $test_count: $@"
 310}
 311
 312test_failure_ () {
 313        test_failure=$(($test_failure + 1))
 314        say_color error "FAIL $test_count: $1"
 315        shift
 316        echo "$@" | sed -e 's/^/        /'
 317        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 318}
 319
 320test_known_broken_ok_ () {
 321        test_fixed=$(($test_fixed+1))
 322        say_color "" "  FIXED $test_count: $@"
 323}
 324
 325test_known_broken_failure_ () {
 326        test_broken=$(($test_broken+1))
 327        say_color skip "  still broken $test_count: $@"
 328}
 329
 330test_debug () {
 331        test "$debug" = "" || eval "$1"
 332}
 333
 334test_run_ () {
 335        eval >&3 2>&4 "$1"
 336        eval_ret="$?"
 337        return 0
 338}
 339
 340test_skip () {
 341        test_count=$(($test_count+1))
 342        to_skip=
 343        for skp in $GIT_SKIP_TESTS
 344        do
 345                case $this_test.$test_count in
 346                $skp)
 347                        to_skip=t
 348                esac
 349        done
 350        if test -z "$to_skip" && test -n "$prereq" &&
 351           ! test_have_prereq "$prereq"
 352        then
 353                to_skip=t
 354        fi
 355        case "$to_skip" in
 356        t)
 357                say_color skip >&3 "skipping test: $@"
 358                say_color skip "skip $test_count: $1"
 359                : true
 360                ;;
 361        *)
 362                false
 363                ;;
 364        esac
 365}
 366
 367test_expect_failure () {
 368        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 369        test "$#" = 2 ||
 370        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 371        if ! test_skip "$@"
 372        then
 373                say >&3 "checking known breakage: $2"
 374                test_run_ "$2"
 375                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 376                then
 377                        test_known_broken_ok_ "$1"
 378                else
 379                        test_known_broken_failure_ "$1"
 380                fi
 381        fi
 382        echo >&3 ""
 383}
 384
 385test_expect_success () {
 386        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 387        test "$#" = 2 ||
 388        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 389        if ! test_skip "$@"
 390        then
 391                say >&3 "expecting success: $2"
 392                test_run_ "$2"
 393                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 394                then
 395                        test_ok_ "$1"
 396                else
 397                        test_failure_ "$@"
 398                fi
 399        fi
 400        echo >&3 ""
 401}
 402
 403test_expect_code () {
 404        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 405        test "$#" = 3 ||
 406        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 407        if ! test_skip "$@"
 408        then
 409                say >&3 "expecting exit code $1: $3"
 410                test_run_ "$3"
 411                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 412                then
 413                        test_ok_ "$2"
 414                else
 415                        test_failure_ "$@"
 416                fi
 417        fi
 418        echo >&3 ""
 419}
 420
 421# test_external runs external test scripts that provide continuous
 422# test output about their progress, and succeeds/fails on
 423# zero/non-zero exit code.  It outputs the test output on stdout even
 424# in non-verbose mode, and announces the external script with "* run
 425# <n>: ..." before running it.  When providing relative paths, keep in
 426# mind that all scripts run in "trash directory".
 427# Usage: test_external description command arguments...
 428# Example: test_external 'Perl API' perl ../path/to/test.pl
 429test_external () {
 430        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 431        test "$#" = 3 ||
 432        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 433        descr="$1"
 434        shift
 435        if ! test_skip "$descr" "$@"
 436        then
 437                # Announce the script to reduce confusion about the
 438                # test output that follows.
 439                say_color "" " run $test_count: $descr ($*)"
 440                # Run command; redirect its stderr to &4 as in
 441                # test_run_, but keep its stdout on our stdout even in
 442                # non-verbose mode.
 443                "$@" 2>&4
 444                if [ "$?" = 0 ]
 445                then
 446                        test_ok_ "$descr"
 447                else
 448                        test_failure_ "$descr" "$@"
 449                fi
 450        fi
 451}
 452
 453# Like test_external, but in addition tests that the command generated
 454# no output on stderr.
 455test_external_without_stderr () {
 456        # The temporary file has no (and must have no) security
 457        # implications.
 458        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 459        stderr="$tmp/git-external-stderr.$$.tmp"
 460        test_external "$@" 4> "$stderr"
 461        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 462        descr="no stderr: $1"
 463        shift
 464        say >&3 "expecting no stderr from previous command"
 465        if [ ! -s "$stderr" ]; then
 466                rm "$stderr"
 467                test_ok_ "$descr"
 468        else
 469                if [ "$verbose" = t ]; then
 470                        output=`echo; echo Stderr is:; cat "$stderr"`
 471                else
 472                        output=
 473                fi
 474                # rm first in case test_failure exits.
 475                rm "$stderr"
 476                test_failure_ "$descr" "$@" "$output"
 477        fi
 478}
 479
 480# This is not among top-level (test_expect_success | test_expect_failure)
 481# but is a prefix that can be used in the test script, like:
 482#
 483#       test_expect_success 'complain and die' '
 484#           do something &&
 485#           do something else &&
 486#           test_must_fail git checkout ../outerspace
 487#       '
 488#
 489# Writing this as "! git checkout ../outerspace" is wrong, because
 490# the failure could be due to a segv.  We want a controlled failure.
 491
 492test_must_fail () {
 493        "$@"
 494        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 495}
 496
 497# test_cmp is a helper function to compare actual and expected output.
 498# You can use it like:
 499#
 500#       test_expect_success 'foo works' '
 501#               echo expected >expected &&
 502#               foo >actual &&
 503#               test_cmp expected actual
 504#       '
 505#
 506# This could be written as either "cmp" or "diff -u", but:
 507# - cmp's output is not nearly as easy to read as diff -u
 508# - not all diff versions understand "-u"
 509
 510test_cmp() {
 511        $GIT_TEST_CMP "$@"
 512}
 513
 514# Most tests can use the created repository, but some may need to create more.
 515# Usage: test_create_repo <directory>
 516test_create_repo () {
 517        test "$#" = 1 ||
 518        error "bug in the test script: not 1 parameter to test-create-repo"
 519        owd=`pwd`
 520        repo="$1"
 521        mkdir -p "$repo"
 522        cd "$repo" || error "Cannot setup test environment"
 523        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 524        error "cannot run git init -- have you built things yet?"
 525        mv .git/hooks .git/hooks-disabled
 526        cd "$owd"
 527}
 528
 529test_done () {
 530        GIT_EXIT_OK=t
 531        test_results_dir="$TEST_DIRECTORY/test-results"
 532        mkdir -p "$test_results_dir"
 533        test_results_path="$test_results_dir/${0%.sh}-$$"
 534
 535        echo "total $test_count" >> $test_results_path
 536        echo "success $test_success" >> $test_results_path
 537        echo "fixed $test_fixed" >> $test_results_path
 538        echo "broken $test_broken" >> $test_results_path
 539        echo "failed $test_failure" >> $test_results_path
 540        echo "" >> $test_results_path
 541
 542        if test "$test_fixed" != 0
 543        then
 544                say_color pass "fixed $test_fixed known breakage(s)"
 545        fi
 546        if test "$test_broken" != 0
 547        then
 548                say_color error "still have $test_broken known breakage(s)"
 549                msg="remaining $(($test_count-$test_broken)) test(s)"
 550        else
 551                msg="$test_count test(s)"
 552        fi
 553        case "$test_failure" in
 554        0)
 555                say_color pass "passed all $msg"
 556
 557                test -d "$remove_trash" &&
 558                cd "$(dirname "$remove_trash")" &&
 559                rm -rf "$(basename "$remove_trash")"
 560
 561                exit 0 ;;
 562
 563        *)
 564                say_color error "failed $test_failure among $msg"
 565                exit 1 ;;
 566
 567        esac
 568}
 569
 570# Test the binaries we have just built.  The tests are kept in
 571# t/ subdirectory and are run in 'trash directory' subdirectory.
 572TEST_DIRECTORY=$(pwd)
 573if test -n "$valgrind"
 574then
 575        make_symlink () {
 576                test -h "$2" &&
 577                test "$1" = "$(readlink "$2")" || {
 578                        # be super paranoid
 579                        if mkdir "$2".lock
 580                        then
 581                                rm -f "$2" &&
 582                                ln -s "$1" "$2" &&
 583                                rm -r "$2".lock
 584                        else
 585                                while test -d "$2".lock
 586                                do
 587                                        say "Waiting for lock on $2."
 588                                        sleep 1
 589                                done
 590                        fi
 591                }
 592        }
 593
 594        make_valgrind_symlink () {
 595                # handle only executables
 596                test -x "$1" || return
 597
 598                base=$(basename "$1")
 599                symlink_target=$TEST_DIRECTORY/../$base
 600                # do not override scripts
 601                if test -x "$symlink_target" &&
 602                    test ! -d "$symlink_target" &&
 603                    test "#!" != "$(head -c 2 < "$symlink_target")"
 604                then
 605                        symlink_target=../valgrind.sh
 606                fi
 607                case "$base" in
 608                *.sh|*.perl)
 609                        symlink_target=../unprocessed-script
 610                esac
 611                # create the link, or replace it if it is out of date
 612                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 613        }
 614
 615        # override all git executables in TEST_DIRECTORY/..
 616        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 617        mkdir -p "$GIT_VALGRIND"/bin
 618        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 619        do
 620                make_valgrind_symlink $file
 621        done
 622        OLDIFS=$IFS
 623        IFS=:
 624        for path in $PATH
 625        do
 626                ls "$path"/git-* 2> /dev/null |
 627                while read file
 628                do
 629                        make_valgrind_symlink "$file"
 630                done
 631        done
 632        IFS=$OLDIFS
 633        PATH=$GIT_VALGRIND/bin:$PATH
 634        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 635        export GIT_VALGRIND
 636elif test -n "$GIT_TEST_INSTALLED" ; then
 637        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 638        error "Cannot run git from $GIT_TEST_INSTALLED."
 639        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 640        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 641else # normal case, use ../bin-wrappers only unless $with_dashes:
 642        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 643        if ! test -x "$git_bin_dir/git" ; then
 644                if test -z "$with_dashes" ; then
 645                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 646                fi
 647                with_dashes=t
 648        fi
 649        PATH="$git_bin_dir:$PATH"
 650        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 651        if test -n "$with_dashes" ; then
 652                PATH="$TEST_DIRECTORY/..:$PATH"
 653        fi
 654fi
 655GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 656unset GIT_CONFIG
 657GIT_CONFIG_NOSYSTEM=1
 658GIT_CONFIG_NOGLOBAL=1
 659export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 660
 661. ../GIT-BUILD-OPTIONS
 662
 663GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 664export GITPERLLIB
 665test -d ../templates/blt || {
 666        error "You haven't built things yet, have you?"
 667}
 668
 669if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 670then
 671        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 672        export GITPYTHONLIB
 673        test -d ../git_remote_helpers/build || {
 674                error "You haven't built git_remote_helpers yet, have you?"
 675        }
 676fi
 677
 678if ! test -x ../test-chmtime; then
 679        echo >&2 'You need to build test-chmtime:'
 680        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 681        exit 1
 682fi
 683
 684# Test repository
 685test="trash directory.$(basename "$0" .sh)"
 686test -n "$root" && test="$root/$test"
 687case "$test" in
 688/*) TRASH_DIRECTORY="$test" ;;
 689 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 690esac
 691test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 692rm -fr "$test" || {
 693        GIT_EXIT_OK=t
 694        echo >&5 "FATAL: Cannot prepare test area"
 695        exit 1
 696}
 697
 698test_create_repo "$test"
 699# Use -P to resolve symlinks in our working directory so that the cwd
 700# in subprocesses like git equals our $PWD (for pathname comparisons).
 701cd -P "$test" || exit 1
 702
 703this_test=${0##*/}
 704this_test=${this_test%%-*}
 705for skp in $GIT_SKIP_TESTS
 706do
 707        to_skip=
 708        for skp in $GIT_SKIP_TESTS
 709        do
 710                case "$this_test" in
 711                $skp)
 712                        to_skip=t
 713                esac
 714        done
 715        case "$to_skip" in
 716        t)
 717                say_color skip >&3 "skipping test $this_test altogether"
 718                say_color skip "skip all tests in $this_test"
 719                test_done
 720        esac
 721done
 722
 723# Provide an implementation of the 'yes' utility
 724yes () {
 725        if test $# = 0
 726        then
 727                y=y
 728        else
 729                y="$*"
 730        fi
 731
 732        while echo "$y"
 733        do
 734                :
 735        done
 736}
 737
 738# Fix some commands on Windows
 739case $(uname -s) in
 740*MINGW*)
 741        # Windows has its own (incompatible) sort and find
 742        sort () {
 743                /usr/bin/sort "$@"
 744        }
 745        find () {
 746                /usr/bin/find "$@"
 747        }
 748        sum () {
 749                md5sum "$@"
 750        }
 751        # git sees Windows-style pwd
 752        pwd () {
 753                builtin pwd -W
 754        }
 755        # no POSIX permissions
 756        # backslashes in pathspec are converted to '/'
 757        # exec does not inherit the PID
 758        ;;
 759*)
 760        test_set_prereq POSIXPERM
 761        test_set_prereq BSLASHPSPEC
 762        test_set_prereq EXECKEEPSPID
 763        ;;
 764esac
 765
 766test -z "$NO_PERL" && test_set_prereq PERL
 767test -z "$NO_PYTHON" && test_set_prereq PYTHON
 768
 769# test whether the filesystem supports symbolic links
 770ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 771rm -f y